#
# NASA_gruhl.R,  3 Aug 16
#
# Data from:
# Lessons Learned cost/schedule assessment guide
# Werner Gruhl
#
# Example from:
# Empirical Software Engineering using R
# Derek M. Jones


source("ESEUR_config.r")

plot_layout(1, 2)



#
# coderev.R, 13 Oct 17
#
# Data from:
# An empirical study on the effectiveness of security code review
# Anne Edmundson and Brian Holtkamp and Emanuel Rivera and Matthew Finifter and Adrian Mettler and David Wagner
#
# R code for book "Empirical Software Engineering using R"
# Derek M. Jones, http://shape-of-code.coding-guidelines.com
#
# Example from:
# Empirical Software Engineering using R
# Derek M. Jones

pal_col=rainbow(2)

# correct,false_report
rev_tf=read.csv(paste0(ESEUR_dir, "regression/coderev-cor_false.csv.xz"))
#rev_tf=rev_tf[-c(30), ]
#rev_tf=rev_tf[-c(28, 29, 30), ]
#rev_tf=rev_tf[-c(11, 22, 24, 25, 26, 27, 28, 29, 30), ]

plot(rev_tf$false_report, rev_tf$correct, col=point_col,
	ylim=c(0, 5),
	xlab="False reports", ylab="Correct reports")

gl_mod=glm(correct ~ false_report, data=rev_tf, family=poisson(link="identity"))

# summary(gl_mod)

y_pred=predict(gl_mod, type="response", se.fit=TRUE)

lines(rev_tf$false_report, y_pred$fit, col=pal_col[1])
lines(rev_tf$false_report, y_pred$fit+1.96*y_pred$se.fit, col=pal_col[2])
lines(rev_tf$false_report, y_pred$fit-1.96*y_pred$se.fit, col=pal_col[2])



gruhl=read.csv(paste0(ESEUR_dir, "regression/NASA_gruhl.csv.xz"), as.is=TRUE)

plot(gruhl$definition.ratio, gruhl$target.overrun, col=point_col,
	xlab="Project definition investment", ylab="Cost overrun\n")

lines(loess.smooth(gruhl$definition.ratio, gruhl$target.overrun, span=0.5), col="green")

e_mod=nls(target.overrun ~ a*exp(b*definition.ratio^0.7), data=gruhl,
			start=list(a=100, b=-0.3))
x_values=1:25
pred=predict(e_mod, newdata=data.frame(definition.ratio=x_values))
lines(x_values, pred, col="red")

# Values done by eye
arrows(3.3, 130, 2.6, 150, col="red")



